diff --git a/lib/hive.rb b/lib/hive.rb
index b22bfe0..851c2bc 100644
--- a/lib/hive.rb
+++ b/lib/hive.rb
@@ -1,5 +1,5 @@
 module Hive
-  VERSION = "0.3.2".freeze
+  VERSION = "0.3.3".freeze
   MIN_CLAUDE_VERSION = "2.1.118".freeze
   # Canonical GitHub org + repo. Referenced by the release probe
   # (UpdateCheck), the brew tap + installer URL (Commands::Update), etc.
diff --git a/lib/hive/claude_launcher.rb b/lib/hive/claude_launcher.rb
index b6820a4..44781d6 100644
--- a/lib/hive/claude_launcher.rb
+++ b/lib/hive/claude_launcher.rb
@@ -128,7 +128,8 @@ module Hive
 
     SessionHandle = Struct.new(:task, :runner, :reestablish, keyword_init: true) do
       def send_and_wait!(prompt:, expected_output: nil, timeout_sec:,
-                         status_mode: nil, log_label: nil, deadline: nil)
+                         status_mode: nil, log_label: nil, deadline: nil,
+                         completion_evidence: nil)
         Hive::ClaudeLauncher.send_prompt_and_wait!(
           task: task,
           runner: runner,
@@ -138,6 +139,7 @@ module Hive
           status_mode: status_mode,
           log_label: log_label,
           deadline: deadline,
+          completion_evidence: completion_evidence,
           reestablish: reestablish
         )
       end
@@ -151,7 +153,8 @@ module Hive
                 allowed_tools: nil,
                 disallowed_tools: nil,
                 permission_mode: nil, mcp_config_path: nil,
-                strict_mcp_config: false)
+                strict_mcp_config: false,
+                completion_evidence: nil)
       profile ||= Hive::AgentProfiles.lookup(:claude, cfg: cfg)
       ensure_claude_profile!(profile)
       permission_mode ||= Hive::Config.claude_permission_mode(cfg)
@@ -202,7 +205,11 @@ module Hive
           expected_output: expected_output,
           timeout_sec: timeout_sec,
           status_mode: status_mode || profile.status_detection_mode,
-          log_label: log_label
+          log_label: log_label,
+          # Tolerant-completion seam (see wait_for_done_signal): nil keeps
+          # byte-for-byte legacy behavior; headless consumes it never —
+          # Hive::Agent has its own exit-code handling.
+          completion_evidence: completion_evidence
         )
       end
       result
@@ -281,7 +288,8 @@ module Hive
 
     def send_prompt_and_wait!(task:, runner:, prompt:, timeout_sec:,
                               expected_output: nil, status_mode: nil,
-                              log_label: nil, deadline: nil, reestablish: nil)
+                              log_label: nil, deadline: nil, reestablish: nil,
+                              completion_evidence: nil)
       reset_signal_files(task)
       cleanup_expected_output(expected_output)
       reestablish_dead_session!(runner, reestablish)
@@ -305,7 +313,8 @@ module Hive
                           started: Time.now.utc.iso8601)
       end
       runner.send_prompt(prompt)
-      result = wait_for_status(task, runner, effective_timeout_sec, status_mode, expected_output, log_label)
+      result = wait_for_status(task, runner, effective_timeout_sec, status_mode, expected_output, log_label,
+                               completion_evidence)
       # Headless launches drop a `<log_label>-<ts>.log` under
       # `task.log_dir`; tmux launches need the same shared log path so
       # downstream Claude-driven stages can find per-invocation output.
@@ -364,7 +373,8 @@ module Hive
       nil
     end
 
-    def wait_for_status(task, runner, timeout, status_mode, expected_output, log_label)
+    def wait_for_status(task, runner, timeout, status_mode, expected_output, log_label,
+                        completion_evidence = nil)
       case status_mode || :state_file_marker
       when :state_file_marker
         marker = wait_for_terminal_marker(task, runner, timeout)
@@ -372,7 +382,7 @@ module Hive
       when :output_file_exists
         wait_for_expected_output(task, runner, timeout, expected_output, log_label)
       when :exit_code_only
-        wait_for_done_signal(task, runner, timeout, log_label)
+        wait_for_done_signal(task, runner, timeout, log_label, completion_evidence)
       else
         raise ArgumentError, "unknown status_mode: #{status_mode.inspect}"
       end
@@ -841,7 +851,7 @@ module Hive
       ""
     end
 
-    def wait_for_done_signal(task, runner, timeout, log_label)
+    def wait_for_done_signal(task, runner, timeout, log_label, completion_evidence = nil)
       deadline = Time.now + timeout
       loop do
         # A usage/credit wall stalls claude WITHOUT ever touching `.done`,
@@ -883,6 +893,18 @@ module Hive
         end
 
         if Time.now >= deadline
+          # Tolerant completion fallback (2026-06-29): tmux-launched fix
+          # phases finished their work yet the Stop-hook handshake never
+          # landed, stranding tasks as `fix_failed` for a missing signal
+          # alone. Convert to :ok ONLY when every generic gate holds AND
+          # the caller's own evidence proves real completion. Without
+          # completion_evidence the deadline branch below is byte-for-byte
+          # legacy behavior — strict timeout.
+          fallback = maybe_complete_without_done_signal(
+            task, runner, pane_tail, log_label, completion_evidence
+          )
+          return fallback if fallback
+
           return { status: :timeout, error_message: "claude stop hook did not signal completion" }
         end
 
@@ -890,6 +912,132 @@ module Hive
       end
     end
 
+    FALLBACK_MISSING_SIGNAL_REASON = ".done sentinel absent at deadline".freeze
+
+    # Shared-tmux-path tolerant completion gate. Runs only at the wait's
+    # deadline and only when the caller supplied completion_evidence.
+    # Generic gates (ALL must hold; any doubt ⇒ strict):
+    #   1. claude_exit_code exists and reads "0" — proves the wrapper ran
+    #      claude to termination with a clean status (see the wrapper's
+    #      instrumentation comment). Absent/nonzero ⇒ strict.
+    #   2. No stall text in the final pane tail — trust/permission prompt or
+    #      a provider-limit wall must never be suppressed. The limit-wall
+    #      priority is already enforced by the caller before this point.
+    #   3. result.json either absent or parses to :ok — anything that
+    #      explicitly reports non-ok from the hook stays strict.
+    #   4. Caller evidence truthy — phases that cannot prove "work actually
+    #      completed" (artifacts + commit/no-change) keep failing strictly.
+    # On success emits one WARN-level `claude_completion_fallback` audit
+    # event (best-effort) and returns :ok WITHOUT an error_message so
+    # callers keep their normal success plumbing.
+    def maybe_complete_without_done_signal(task, runner, pane_tail, log_label, completion_evidence)
+      return nil unless completion_evidence
+
+      exit_code = read_claude_exit_code(task)
+      return nil unless exit_code == "0"
+
+      tail = pane_tail.to_s
+      return nil if CLAUDE_TRUST_PROMPT_MARKERS.any? { |marker| tail.include?(marker) }
+      return nil if tail.include?(CLAUDE_PERMISSION_PROMPT_MARKER)
+
+      result_status = read_result_json_status(task)
+      return nil unless result_status.nil? || result_status == :ok
+
+      evidence = evaluate_completion_evidence(completion_evidence, pane_tail)
+      return nil unless evidence
+
+      detail = evidence.is_a?(Hash) ? evidence : { summary: evidence.to_s }
+      emit_completion_fallback_event(task, runner, detail)
+
+      {
+        status: :ok,
+        log_label: log_label,
+        fallback: {
+          reason: FALLBACK_MISSING_SIGNAL_REASON,
+          exit_code: exit_code,
+          evidence: fallback_evidence_summary(detail)
+        }
+      }
+    end
+
+    def read_claude_exit_code(task)
+      path = exit_code_path(task)
+      return nil unless File.exist?(path)
+
+      content = File.read(path).to_s.strip
+      return nil if content.empty?
+
+      content
+    rescue SystemCallError, IOError => e
+      warn "[hive] could not read #{path}: #{e.class}: #{e.message}"
+      nil
+    end
+
+    def evaluate_completion_evidence(callback, pane_tail)
+      callback.call({ pane_tail: pane_tail.to_s })
+    rescue StandardError => e
+      # A raising evidence provider is indistinguishable from "cannot prove
+      # completion" — fail strictly rather than suppress.
+      warn "[hive] completion_evidence callback raised #{e.class}: #{e.message}; treating as no-evidence"
+      nil
+    end
+
+    def fallback_evidence_summary(detail)
+      summary = detail.filter_map do |key, value|
+        next if value.nil?
+
+        "#{key}=#{value}"
+      end.join(" ")
+      summary[0, 300]
+    end
+
+    # WARN-level audit record that a missing Stop-hook signal was tolerated
+    # on exit-0 + caller evidence. Message is bounded by Events' own
+    # MAX_MESSAGE_BYTES truncation. Emission failure must never alter the
+    # spawn's envelope (mirrors capture_pane_log best-effort contract).
+    def emit_completion_fallback_event(task, runner, detail)
+      message = [
+        "phase=#{detail[:phase] || 'unknown'}",
+        detail[:pass] ? "pass=#{format('%02d', Integer(detail[:pass]))}" : nil,
+        "session=#{session_name_safely(runner)}",
+        "expected=#{done_path(task)}",
+        "reason=#{FALLBACK_MISSING_SIGNAL_REASON}",
+        "artifacts=#{detail[:artifacts] || 'unspecified'}",
+        "commit_evidence=#{detail[:commit_evidence] || 'unspecified'}",
+        "slug=#{task_slug(task)}"
+      ].compact.join(" ")
+      Hive::Events.emit(
+        task_folder: task.folder,
+        slug: task_slug(task),
+        stage: fallback_event_stage(task),
+        agent: "claude",
+        event_type: :claude_completion_fallback,
+        message: message
+      )
+    rescue StandardError => e
+      warn "[hive] could not emit claude_completion_fallback event: #{e.class}: #{e.message}"
+      nil
+    end
+
+    def session_name_safely(runner)
+      name = runner.respond_to?(:name) ? runner.name : nil
+      name && !name.to_s.empty? ? name : "(unknown)"
+    rescue StandardError
+      "(unknown)"
+    end
+
+    def fallback_event_stage(task)
+      if task.respond_to?(:stage_index) && task.respond_to?(:stage_name) && task.stage_index
+        "#{task.stage_index}-#{task.stage_name}"
+      elsif task.respond_to?(:stage_name) && task.stage_name
+        task.stage_name.to_s
+      else
+        ""
+      end
+    rescue StandardError
+      ""
+    end
+
     # Read `result.json` (if present) and translate `status` into the
     # caller's symbol vocabulary. Unknown / unparseable shapes return
     # nil so the caller can fall through to its default success path.
@@ -1060,6 +1208,8 @@ module Hive
     def cleanup_done(task)
       path = done_path(task)
       File.delete(path) if File.exist?(path)
+      exit_path = exit_code_path(task)
+      File.delete(exit_path) if File.exist?(exit_path)
     end
 
     def cleanup_scratch(settings_path)
@@ -1097,6 +1247,16 @@ module Hive
       File.join(task.folder, ".done")
     end
 
+    # Scratch file written by interactive_claude_wrapper.sh immediately
+    # before it exits, carrying claude's true exit status. Its presence
+    # proves "the agent process ran to termination" independent of Stop-hook
+    # delivery (which has been observed missing on clean exits — see wiki
+    # [[stages/review]]). Reset/cleaned alongside .done and result.json so no
+    # stale residue from a previous spawn leaks into the next wait loop.
+    def exit_code_path(task)
+      File.join(task.folder, "claude_exit_code")
+    end
+
     def result_path(task)
       File.join(task.folder, "result.json")
     end
diff --git a/lib/hive/events.rb b/lib/hive/events.rb
index 31ecc07..f8bca81 100644
--- a/lib/hive/events.rb
+++ b/lib/hive/events.rb
@@ -14,6 +14,7 @@ module Hive
       round_waiting
       round_complete
       clean_exit_auto_committed
+      claude_completion_fallback
     ].freeze
 
     STATUS_TAIL_LINES = 20
diff --git a/lib/hive/scripts/interactive_claude_wrapper.sh b/lib/hive/scripts/interactive_claude_wrapper.sh
index 4ddd43f..a7935dc 100755
--- a/lib/hive/scripts/interactive_claude_wrapper.sh
+++ b/lib/hive/scripts/interactive_claude_wrapper.sh
@@ -102,4 +102,29 @@ unset CLAUDE_API_KEY
 # delete this `unset` thinking the explicit pass-through makes it a no-op.
 unset HIVE_SCREENOTE_BASE_URL
 
-exec "$bin" "$@"
+# Run claude WITHOUT `exec` so this wrapper survives long enough to persist
+# claude's true exit status. The Stop-hook completion handshake
+# (${HIVE_TASK_STAGE_DIR}/result.json + .done) is written by a Claude Code
+# hook process and has been observed missing even when the agent finished
+# its work (commits landed, session closed cleanly). claude_exit_code is
+# written by THIS process immediately before exiting, so its presence proves
+# "claude ran to termination" independent of hook delivery, letting
+# ClaudeLauncher distinguish "clean exit, signal lost" from "agent never
+# exited / pane unreadable". Scratched/reset alongside .done and result.json
+# by ClaudeLauncher.reset_signal_files — see Hive::ClaudeLauncher.exit_code_path.
+#
+# `set -e` must be suspended around the child or a non-zero claude exit
+# would abort the script before the file write below lands.
+set +e
+"$bin" "$@"
+status=$?
+set -e
+
+stage_dir=${HIVE_TASK_STAGE_DIR:-}
+if [ -n "$stage_dir" ]; then
+  # Best-effort: a read-only task folder must not mask claude's real exit
+  # status. An empty/partial file is tolerated as "unknown" by readers.
+  printf '%s\n' "$status" > "${stage_dir}/claude_exit_code" || true
+fi
+
+exit "$status"
diff --git a/lib/hive/scripts/stop_hook.sh b/lib/hive/scripts/stop_hook.sh
index 086433f..84bfe6b 100755
--- a/lib/hive/scripts/stop_hook.sh
+++ b/lib/hive/scripts/stop_hook.sh
@@ -16,3 +16,40 @@ else
   printf '%s' "$payload" > "$result_path"
 fi
 touch "${HIVE_TASK_STAGE_DIR}/.done"
+
+# Best-effort forensic trail for the "hook ran but .done absent" class of
+# incident (tmux fix phases stranding as REVIEW_ERROR reason=fix_failed).
+# Every completion attempt appends one line to <task folder>/stop-hook.log;
+# the log is size-capped like ClaudeLauncher's orphan-sweep log. The whole
+# block is failure-isolated: logging must never alter the hook's exit path
+# (a failing hook surfaces as a broken Stop event, which is exactly the
+# bug this instrumentation exists to diagnose).
+STOP_HOOK_LOG="${HIVE_TASK_STAGE_DIR}/stop-hook.log"
+STOP_HOOK_LOG_MAX_BYTES=65536
+
+observe() {
+  (
+    set +eu
+    stdin_bytes=$(printf '%s' "$payload" | wc -c)
+    result_state=absent
+    [ -f "$result_path" ] && result_state=written
+    done_state=no
+    [ -e "${HIVE_TASK_STAGE_DIR}/.done" ] && done_state=yes
+    if [ -f "$STOP_HOOK_LOG" ]; then
+      log_bytes=$(wc -c < "$STOP_HOOK_LOG" 2>/dev/null)
+      case "$log_bytes" in
+        ''|*[!0-9]*) log_bytes=0 ;;
+      esac
+      if [ "$log_bytes" -ge "$STOP_HOOK_LOG_MAX_BYTES" ]; then
+        printf '[%s] (log truncated, prior contents exceeded %s bytes)\n' \
+          "$(date -u +%Y-%m-%dT%H:%M:%SZ)" "$STOP_HOOK_LOG_MAX_BYTES" \
+          > "$STOP_HOOK_LOG"
+      fi
+    fi
+    printf '[%s] stage=%s stdin_bytes=%s result_written=%s done_written=%s\n' \
+      "$(date -u +%Y-%m-%dT%H:%M:%SZ)" "$HIVE_TASK_STAGE_DIR" \
+      "$stdin_bytes" "$result_state" "$done_state" \
+      >> "$STOP_HOOK_LOG" 2>/dev/null || true
+  ) >/dev/null 2>&1 || true
+}
+observe
diff --git a/lib/hive/stages/base.rb b/lib/hive/stages/base.rb
index 979b480..11e66bc 100644
--- a/lib/hive/stages/base.rb
+++ b/lib/hive/stages/base.rb
@@ -562,7 +562,7 @@ module Hive
                          profile: nil, expected_output: nil, status_mode: nil,
                          permission_mode: nil, allowed_tools: nil,
                          disallowed_tools: nil, mcp_config_path: nil,
-                         strict_mcp_config: false)
+                         strict_mcp_config: false, completion_evidence: nil)
         require "hive/claude_launcher"
 
         profile ||= Hive::AgentProfiles.lookup(:claude, cfg: cfg)
@@ -588,7 +588,11 @@ module Hive
           allowed_tools: allowed_tools,
           disallowed_tools: disallowed_tools,
           mcp_config_path: mcp_config_path,
-          strict_mcp_config: strict_mcp_config
+          strict_mcp_config: strict_mcp_config,
+          # Tolerant-completion seam (tmux wait_for_done_signal). Headless
+          # consumes it never — Hive::Agent derives status from the real
+          # exit code already — so dropping it on that branch is safe.
+          completion_evidence: completion_evidence
         )
       end
 
diff --git a/lib/hive/stages/completion_evidence.rb b/lib/hive/stages/completion_evidence.rb
new file mode 100644
index 0000000..0ec8c07
--- /dev/null
+++ b/lib/hive/stages/completion_evidence.rb
@@ -0,0 +1,87 @@
+# Shared evidence predicates for ClaudeLauncher's tolerant-completion
+# fallback seam (2026-06-29). Every `:exit_code_only` consumer (6-review fix,
+# 6-review ci-fix, 4-execute) builds its own evidence callable; the helpers
+# here keep the generic pieces single-sourced so sibling stages cannot drift.
+#
+# The seam's hard rule: any doubt must fail STRICT (the launcher keeps its
+# "claude stop hook did not signal completion" timeout unless every gate
+# holds), so these helpers deliberately prefer returning false/narrow matches
+# over creative inference.
+module Hive
+  module Stages
+    module CompletionEvidence
+      # Explicit no-change resolution language an implementer uses when it
+      # concluded no worktree change is warranted this pass. Only the final
+      # pane tail is scanned, and these are AND-gated with artifact parsing
+      # and a still-readable worktree upstream, so a false positive cannot
+      # fabricate completion out of thin air.
+      NO_CHANGE_PATTERNS = [
+        /no (?:code )?changes? (?:are |were )?(?:needed|required)/i,
+        /no changes (?:were |are )?(?:made|applied|committed)/i,
+        /nothing (?:to fix|left to fix|needed changing)/i,
+        /all findings? (?:were |are )?already (?:resolved|addressed|applied|fixed)/i,
+        /findings? (?:are |were )?already fixed/i,
+        /already resolved\/no-fix/i
+      ].freeze
+
+      module_function
+
+      def explicit_no_change?(text)
+        normalized = text.to_s.gsub(/\s+/, " ")
+        NO_CHANGE_PATTERNS.any? { |pattern| normalized.match?(pattern) }
+      end
+
+      # Readable-worktree + commit-since-baseline in one probe. A broken or
+      # vanished worktree (git_head nil) is never "evidence" — strict.
+      def head_moved?(worktree_path, baseline_head)
+        current = Hive::Stages::AutoCommit.git_head(worktree_path)
+        return false if current.nil?
+        return false if baseline_head.to_s.empty?
+
+        current != baseline_head
+      end
+
+      # Short SHAs keep fallback evidence messages inside Events' message budget.
+      def short_sha(sha)
+        sha.to_s[0, 7]
+      end
+
+      # Generic implementer evidence for siblings whose orchestrator runs
+      # its own downstream validation (4-execute's run_pass guards, ci-fix
+      # re-running CI): readable worktree + commit-since-baseline OR an
+      # explicit no-change assertion. An unresolvable baseline (nil / not
+      # SHA-shaped) downgrades to no-change-only — conservative direction.
+      # `artifacts_check` supplies the caller's own artifact probe; it must
+      # return a truthy label (String) or the whole verdict fails strict.
+      def change_or_no_change_evidence(worktree_path:, baseline_head:,
+                                       phase:, pass: nil, artifacts_check: nil)
+        sha_like = baseline_head.to_s.match?(/\A[0-9a-f]{7,40}\z/)
+        lambda do |probe|
+          label = artifacts_check ? artifacts_check.call : "worktree readable"
+          return false unless label
+
+          current = Hive::Stages::AutoCommit.git_head(worktree_path)
+          return false unless current
+
+          if sha_like && current != baseline_head
+            {
+              phase: phase,
+              pass: pass,
+              artifacts: label,
+              commit_evidence: "HEAD moved #{short_sha(baseline_head)} -> #{short_sha(current)}"
+            }
+          elsif explicit_no_change?(probe[:pane_tail])
+            {
+              phase: phase,
+              pass: pass,
+              artifacts: label,
+              commit_evidence: "explicit no-change assertion in agent final output"
+            }
+          else
+            false
+          end
+        end
+      end
+    end
+  end
+end
diff --git a/lib/hive/stages/execute.rb b/lib/hive/stages/execute.rb
index c3081b8..e6b0030 100644
--- a/lib/hive/stages/execute.rb
+++ b/lib/hive/stages/execute.rb
@@ -8,6 +8,8 @@ require "hive/dependencies"
 require "hive/dependency_snapshot"
 require "hive/protected_files"
 require "hive/stages/base"
+require "hive/stages/auto_commit"
+require "hive/stages/completion_evidence"
 require "hive/worktree"
 require "hive/git_ops"
 require "hive/markers"
@@ -129,7 +131,7 @@ module Hive
         return worktree_git_failed(task) unless baseline_head
 
         before_impl = Hive::ProtectedFiles.snapshot(task.folder, PROTECTED_FILES)
-        impl_result = spawn_implementation(task, cfg, worktree_path)
+        impl_result = spawn_implementation(task, cfg, worktree_path, baseline_head: baseline_head)
         after_impl = Hive::ProtectedFiles.snapshot(task.folder, PROTECTED_FILES)
         append_implementation_output(task, impl_result)
 
@@ -233,7 +235,7 @@ module Hive
         nil
       end
 
-      def spawn_implementation(task, cfg, worktree_path)
+      def spawn_implementation(task, cfg, worktree_path, baseline_head: nil)
         plan_text = File.read(File.join(task.folder, "plan.md"))
         prompt = Hive::Stages::Base.render(
           "execute_prompt.md.erb",
@@ -281,13 +283,39 @@ module Hive
             task,
             cfg,
             **kwargs,
-            session_name: Hive::ClaudeLauncher.tmux_session_name("4-execute", task) # coding-scoped: coding execute stage tmux session
+            session_name: Hive::ClaudeLauncher.tmux_session_name("4-execute", task), # coding-scoped: coding execute stage tmux session
+            # Tolerant-completion seam (U4): a clean-exited implementer whose
+            # stop-hook signal was lost must not be attributed as a hard
+            # `implementer_failed status=timeout`. run_pass's own guards —
+            # branch check, ancestor check, dirty/no-changes/research-output
+            # gates — still fully apply and park hollow completions via the
+            # execute_waiting_* markers instead of this spurious failure.
+            completion_evidence: completion_evidence_for_execute(
+              task: task,
+              worktree_path: worktree_path,
+              baseline_head: baseline_head,
+              profile: profile
+            )
           )
         else
           Hive::Stages::Base.spawn_agent(task, **kwargs)
         end
       end
 
+      def completion_evidence_for_execute(task:, worktree_path:, baseline_head:, profile:)
+        return nil unless profile.name == :claude
+
+        plan_path = File.join(task.folder, "plan.md")
+        Hive::Stages::CompletionEvidence.change_or_no_change_evidence(
+          worktree_path: worktree_path,
+          baseline_head: baseline_head,
+          phase: "execute",
+          artifacts_check: -> {
+            File.exist?(plan_path) ? "plan.md present (SHA-protected around spawn)" : false
+          }
+        )
+      end
+
       def record_tamper(task, tampered, who:)
         Hive::Markers.set(task.state_file, :error,
                           reason: "#{who}_tampered",
diff --git a/lib/hive/stages/review.rb b/lib/hive/stages/review.rb
index 7ca0fb2..503e440 100644
--- a/lib/hive/stages/review.rb
+++ b/lib/hive/stages/review.rb
@@ -10,6 +10,7 @@ require "hive/claude_launcher"
 require "hive/stages/base"
 require "hive/stages/auto_commit"
 require "hive/stages/clean_exit"
+require "hive/stages/completion_evidence"
 require "hive/worktree"
 require "hive/git_ops"
 require "hive/markers"
@@ -582,7 +583,12 @@ module Hive
           before_fix_sha = Hive::ProtectedFiles.snapshot(task.folder, protected_set)
           before_fix_head = git_head(worktree_path)
 
-          fix_result = spawn_fix_agent(task, cfg, ctx_pass, accepted: accepted)
+          fix_result = spawn_fix_agent(
+            task, cfg, ctx_pass,
+            accepted: accepted,
+            before_fix_head: before_fix_head,
+            accepted_findings_text: accepted
+          )
           after_fix_sha = Hive::ProtectedFiles.snapshot(task.folder, protected_set)
           after_fix_head = git_head(worktree_path)
 
@@ -1812,7 +1818,66 @@ module Hive
         File.write(path, body)
       end
 
-      def spawn_fix_agent(task, cfg, ctx, accepted:)
+      # Tolerant-completion fallback seam (U2/U3). Evidence provider for the
+      # fix phase's tmux spawn: returns a detail Hash ONLY when ALL of the
+      # acceptance predicate holds —
+      #   1. worktree readable (`git rev-parse` sanity),
+      #   2. required pass artifacts exist and parse consistently with the
+      #      accepted-findings set computed pre-spawn (reviewer files +
+      #      escalations doc are orchestrator-owned and SHA-guarded around
+      #      the spawn, so a mid-pass rewrite fails strictly),
+      #   3. no new unresolved-escalation state since spawn time,
+      #   4. commit-since-pass-start (HEAD moved off before_fix_head) OR an
+      #      explicit no-change resolution assertion in the agent's final
+      #      pane tail (persisted post-hoc via capture_pane_log + the
+      #      claude_completion_fallback event payload).
+      # Any miss returns falsey so wait_for_done_signal keeps the strict
+      # `fix_failed` timeout. When the envelope converts to :ok, downstream
+      # tamper/auto-commit/guardrail/write_fix_success logic runs unchanged.
+      def fix_completion_evidence(ctx, worktree_path:, before_fix_head:, accepted_findings_text:)
+        escalations_before = count_escalations(ctx)
+        lambda do |probe|
+          current_head = git_head(worktree_path)
+          return false unless current_head
+
+          return false unless fix_pass_artifacts_consistent?(ctx, accepted_findings_text: accepted_findings_text)
+          return false unless count_escalations(ctx) == escalations_before
+
+          if before_fix_head && current_head != before_fix_head
+            {
+              phase: "fix",
+              pass: ctx.pass,
+              artifacts: "reviewer+escalations docs parse",
+              commit_evidence: "HEAD moved #{Hive::Stages::CompletionEvidence.short_sha(before_fix_head)} -> #{Hive::Stages::CompletionEvidence.short_sha(current_head)}"
+            }
+          else
+            return false unless Hive::Stages::CompletionEvidence.explicit_no_change?(probe[:pane_tail])
+
+            {
+              phase: "fix",
+              pass: ctx.pass,
+              artifacts: "reviewer+escalations docs parse",
+              commit_evidence: "explicit no-change assertion in agent final output"
+            }
+          end
+        end
+      end
+
+      def fix_pass_artifacts_consistent?(ctx, accepted_findings_text:)
+        suffix = format("%02d", ctx.pass)
+        reviewer_files = Dir[File.join(ctx.task_folder, "reviews", "*-#{suffix}.md")].select do |path|
+          reviewer_file?(File.basename(path))
+        end
+        return false if reviewer_files.empty?
+
+        return false unless File.exist?(Hive::Stages::Review::Triage.escalations_path(ctx))
+
+        collect_accepted_findings_with_count(ctx).text == accepted_findings_text.to_s
+      rescue SystemCallError, IOError
+        false
+      end
+
+      def spawn_fix_agent(task, cfg, ctx, accepted:, before_fix_head: nil, accepted_findings_text: nil)
         profile_name = cfg.dig("review", "fix", "agent") || "claude"
         profile = Hive::AgentProfiles.lookup(profile_name, cfg: cfg)
         scope = Hive::Stages::Base.stage_permission_scope(
@@ -1857,7 +1922,13 @@ module Hive
             task,
             cfg,
             **kwargs,
-            session_name: Hive::ClaudeLauncher.tmux_session_name("6-review-fix-pass#{ctx.pass}", task)
+            session_name: Hive::ClaudeLauncher.tmux_session_name("6-review-fix-pass#{ctx.pass}", task),
+            completion_evidence: fix_completion_evidence(
+              ctx,
+              worktree_path: ctx.worktree_path,
+              before_fix_head: before_fix_head,
+              accepted_findings_text: accepted_findings_text
+            )
           )
         else
           Hive::Stages::Base.spawn_agent(task, **kwargs)
diff --git a/lib/hive/stages/review/ci_fix.rb b/lib/hive/stages/review/ci_fix.rb
index dad7257..3fd09af 100644
--- a/lib/hive/stages/review/ci_fix.rb
+++ b/lib/hive/stages/review/ci_fix.rb
@@ -6,6 +6,8 @@ require "hive/agent_profiles"
 require "hive/claude_launcher"
 require "hive/protected_files"
 require "hive/reviewers/synthetic_task"
+require "hive/stages/auto_commit"
+require "hive/stages/completion_evidence"
 require "hive/stages/base"
 
 module Hive
@@ -115,13 +117,15 @@ module Hive
             end
 
             before = Hive::ProtectedFiles.snapshot(ctx.task_folder, PROTECTED_FILES)
+            baseline_head = Hive::Stages::AutoCommit.git_head(ctx.worktree_path)
             spawn_result = spawn_fix_agent(
               cfg: cfg,
               ctx: ctx,
               command: command,
               attempt: attempts,
               max_attempts: max_attempts,
-              captured_output: output
+              captured_output: output,
+              baseline_head: baseline_head
             )
             after = Hive::ProtectedFiles.snapshot(ctx.task_folder, PROTECTED_FILES)
             tampered = Hive::ProtectedFiles.diff(before, after)
@@ -328,7 +332,8 @@ module Hive
           status.success? && !out.empty?
         end
 
-        def spawn_fix_agent(cfg:, ctx:, command:, attempt:, max_attempts:, captured_output:)
+        def spawn_fix_agent(cfg:, ctx:, command:, attempt:, max_attempts:, captured_output:,
+                            baseline_head: nil)
           profile_name = cfg.dig("review", "ci", "agent") || "claude"
           profile = Hive::AgentProfiles.lookup(profile_name, cfg: cfg)
 
@@ -375,7 +380,20 @@ module Hive
               task,
               cfg,
               **kwargs,
-              session_name: Hive::ClaudeLauncher.tmux_session_name("6-review-ci-fix-attempt#{attempt}", task)
+              session_name: Hive::ClaudeLauncher.tmux_session_name("6-review-ci-fix-attempt#{attempt}", task),
+              # Tolerant-completion seam (U4): a clean-exited ci-fix pass whose
+              # Stop-hook signal was lost must flow back into the loop, which
+              # re-runs CI and lets the green/red verdict decide — the loop's
+              # own validation stays fully in charge of hollow completions.
+              completion_evidence: Hive::Stages::CompletionEvidence.change_or_no_change_evidence(
+                worktree_path: ctx.worktree_path,
+                baseline_head: baseline_head,
+                phase: "ci",
+                pass: attempt,
+                artifacts_check: -> {
+                  captured_output.to_s.strip.empty? ? false : "captured CI failure log (#{captured_output.bytesize} bytes)"
+                }
+              )
             )
           else
             Hive::Stages::Base.spawn_agent(task, **kwargs)
